<?xml version="1.0"?>

<!--

	This is XML Stylesheet in XSLT to translate
	a DHTML specification to a HTML file with JavaScript and DOM.

-->

<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:dxml="dummy_uri_for_dxml">

	<xsl:output method="html"/>
	<xsl:template match="dxml:dxml">
		<html>
		<head>		
		<script>
		<xsl:apply-templates select="./*"/>

		var doc_window;
		function dxml_init()
		{
			<xsl:for-each select="./*">
			setTimeout("dxml_command_<xsl:value-of select='position()'/>()", 1000 * <xsl:value-of select="@time"/>);
			</xsl:for-each>
			doc_window = window.open('', 'doc_window', 'top=0, left=0, width=800, height=600');
		}
		</script>
		<body onLoad="dxml_init()">
		<form>
		<xsl:for-each select="./*">
			<input type="hidden">
				<xsl:attribute name="name">dxml_command_<xsl:value-of select='position()'/></xsl:attribute>
				<xsl:attribute name="id">dxml_command_<xsl:value-of select='position()'/></xsl:attribute>
				<xsl:attribute name="value"><xsl:value-of select='.'/></xsl:attribute>
			</input>
		</xsl:for-each>
		</form>
		</body>
		<xml id="xmldoc"></xml>
		<xml id="xmlstyle"></xml>
		</head>
		</html>
	</xsl:template>

	<!-- attribute related commands -->

	<xsl:template match="dxml:insertAttribute">
		function dxml_command_<xsl:value-of select='position()'/>()
		{
			doc_window.document.all("<xsl:value-of select='@element'/>").<xsl:value-of select='@attribute'/> = "<xsl:value-of select='@value'/>";
		}
	</xsl:template>

	<xsl:template match="dxml:deleteAttribute">
		function dxml_command_<xsl:value-of select='position()'/>()
		{
			doc_window.document.all("<xsl:value-of select='@element'/>").<xsl:value-of select='@attribute'/> = "";
		}	
	</xsl:template>

	<xsl:template match="dxml:replaceAttribute">
		function dxml_command_<xsl:value-of select='position()'/>()
		{
			doc_window.document.all("<xsl:value-of select='@element'/>").<xsl:value-of select='@attribute'/> = "<xsl:value-of select='@value'/>";
		}	
	</xsl:template>

	<!-- element related commands -->

	<xsl:template match="dxml:deleteElement">
		function dxml_command_<xsl:value-of select='position()'/>()
		{
			doc_window.document.all("<xsl:value-of select='@element'/>").outerHTML = "";
		}
	</xsl:template>

	<xsl:template match="dxml:insertElement">
		function dxml_command_<xsl:value-of select='position()'/>()
		{			
			<xsl:choose>
				<xsl:when test='@before'>
					doc_window.document.all("<xsl:value-of select='@before'/>").outerHTML = document.forms[0].elements["dxml_command_<xsl:value-of select='position()'/>"].value
								+ doc_window.document.all("<xsl:value-of select='@before'/>").outerHTML ;
				</xsl:when>

				<xsl:when test='@after'>
					doc_window.document.all("<xsl:value-of select='@after'/>").outerHTML += document.forms[0].elements["dxml_command_<xsl:value-of select='position()'/>"].value;
				</xsl:when>
			</xsl:choose>			
		}
	</xsl:template>

	<xsl:template match="dxml:replaceElement">
		function dxml_command_<xsl:value-of select='position()'/>()
		{
			doc_window.document.all("<xsl:value-of select='@element'/>").outerHTML = document.forms[0].elements["dxml_command_<xsl:value-of select='position()'/>"].value;
		}
	</xsl:template>
	
	<xsl:template match="dxml:replaceDocument">
		function dxml_command_<xsl:value-of select='position()'/>()
		{
		<xsl:choose>
			<xsl:when test="@href">
			doc_window.document.location = "<xsl:value-of select="@href"/>";
			</xsl:when>
			<xsl:otherwise>
			with(doc_window.document)
			{
				open();
				write(document.forms[0].elements["dxml_command_<xsl:value-of select='position()'/>"].value);
				close();
			}
			</xsl:otherwise>
		</xsl:choose>
		}
	</xsl:template>
	
</xsl:stylesheet>


